# $Header: /alx-cvs/alx-src/tinyalxconfig-ng/functions/config_modules.sh,v 1.5 2008/06/06 23:31:00 niro Exp $
# configures printing on the host via mysql db settings
# Note must be the first configure script which will be startet

add_modules()
{
	local modules="$@"
	local modfile="/etc/modules.autoload"
	local mod

	for mod in ${modules}
	do
		[[ -n $(find /lib/modules/$(uname -r) -name ${mod}.[o,k]*) ]] && \
			echo "${mod}" >> ${modfile}
	done
}

config_modules()
{
	local modfile
	local modules_list

	# location of the modules.autoload file
	modfile="/etc/modules.autoload"

	# clear the old one
	:> ${modfile}

	# needed for printing:
	add_modules lp parport parport_pc

	# get all available modules-ids
	modules_list=$(mysqldo "select module from cfg_modules where serial='${ALX_SERIAL}'")
	[[ ! -z ${modules_list} ]] && add_modules ${modules_list}

	# network modules - but exclude "auto" modules
	modules_list=$(mysqldo "select module from cfg_interfaces where serial='${ALX_SERIAL}' and not module='auto'")
	[[ ! -z ${modules_list} ]] && add_modules ${modules_list}

	# fixme: does udev handle this already?? i think so!
	# special agp and drm modules needed by some graphic drivers
	evaluate_table_xml cfg_graphic
	case ${cfg_grafic_module} in
		# intel i810 needs intel-agp module to work probably
		i810) add_modules intel-agp ;;
	esac
}
